<?php
// Copyright 2005 by Han-gil Lee <hangulee at gmail.com>
// All rights reserved. Distributable under GPL see COPYING
// table plugin for the MoniWiki
//
// Usage: {{{#!table [table option]
// 
// }}}
// cell devision : "||"
// row devision : "===="
// blank cell is combinning with before or upper cell
// that is not empty. if you want to cell forced combine
// with before cell, then you write down "_" instead of blank
//
// table option
// border=? & width=? & cellpadding=? & cellspacing=? & th & attr
//   & bgcolor=? ...
// 
// option : attr
// if you use option that 'attr', then you descript
// colum attribute(width, border, align, valign)

function table_makeOptionSet($string)
{
	$args = explode("&", trim($string));
	foreach($args as $arg)
	{
		list($arg_name, $arg_value) = explode("=",$arg,2);
		$args[trim($arg_name)]=trim($arg_value);
	}
	return $args;
}


function processor_table($formatter,$value="") {
	if ($value[0]=='#' and $value[1]=='!')
		list($line,$value) = explode("\n",$value,2);
	
	list($processor_name, $args) = explode(" ", $line, 2);
	$args = table_makeOptionSet($args);
	
	if(isset($args['attr']))
	{
		list($attr, $value) = explode("====", $value, 2);
		$attr = explode("||", $attr);
		$colCount = count($attr);
		for($i=0; $i<$colCount; $i++)
			$attrs[$i] = table_makeOptionSet($attr[$i]);
	}
	
	$rows = explode("====", $value);
	$rowCount = count($rows);
	for($i=0; $i<$rowCount; $i++)
		$rows[$i] = explode("||", $rows[$i]);
	
	$colCount = count($rows[0]);
	if($colCount==1 and !empty($rows[1]))
		$colCount = count($rows[1]);
	
	
	for($i=0; $i<$rowCount; $i++) $rowPs[$i] = 0;
	$colPs = 0;

	for($i=0; $i<$rowCount; $i++)
	{
		for($j=0; $j<$colCount; $j++)
		{
			$rpn[$i][$j] = 0;
			$cpn[$i][$j] = 0;
		
			$rows[$i][$j] = table_trim($rows[$i][$j]);
			//if($rows[$i][$j]=='') $rows[$i][$j]="&nbsp;";
			
			if( empty($rows[$i][$j]) or $rows[$i][$j]=="_" )
			{
				// 위에보기
				if( !empty($rows[$rowPs[$j]][$j])
					and $rows[$i][$j]!="_") {
					$rpn[$rowPs[$j]][$j]++;
				}
				// 앞에보기
				else if( !empty($rows[$i][$colPs]) ) {
					$cpn[$i][$colPs]++;
				}
				else {
					$cpn[$i][$j]++;
					$rpn[$i][$j]++;
				}
			}
			else {
				$rowPs[$j] = $i;
				$colPs = $j;
				$cpn[$i][$j]++;
				$rpn[$i][$j]++;
			}
		}
	}
	
	$th_max = (isset($args["th"]) ? max($cpn[0]) : 0);
	
	ob_start();
	
	echo "<table class='wiki' ";
	if($args["width"]) echo " width='".$args["width"]."'";
	if($args["border"]) echo " border='".$args["border"]."'";
	if($args["bgcolor"]) echo " bgcolor='".$args["bgcolor"]."'";
	if($args["cellpadding"]) echo " cellpadding='".$args["cellpadding"]."'";
	if($args["cellspacing"]) echo " cellspacing='".$args["cellspacing"]."'";
	echo ">\n";
	
	for($i=0; $i<$rowCount; $i++)
	{
		echo "<tr class='wiki'>\n";
		for($j=0; $j<$colCount; $j++)
		{
			if( $rpn[$i][$j] and $cpn[$i][$j] ) {
				if($i<$th_max) echo "<th";
				else echo "<td";
				
				if( $rpn[$i][$j]>1 )
					echo " rowspan='".$rpn[$i][$j]."'";
				if( $cpn[$i][$j]>1 )
					echo " colspan='".$cpn[$i][$j]."'";

				if( isset($attrs[$j]['width']) )
					echo " width='".$attrs[$j]['width']."'";
				if( isset($attrs[$j]['bgcolor']) )
					echo " bgcolor='".$attrs[$j]['bgcolor']."'";
				if( isset($attrs[$j]['align']) )
					echo " align='".$attrs[$j]['align']."'";
				if( isset($attrs[$j]['valign']) )
					echo " valign='".$attrs[$j]['valign']."'";
				
				echo " class='wiki'>\n";
				$formatter->send_page($rows[$i][$j]);
				
				//$out .= ":".$rpn[$i][$j];
				//$out .= ":".$cpn[$i][$j];
				
				if($i<$th_max) echo "</th>";
				else echo "</td>\n";
			}
		}
		echo "</tr>\n";
	}
	echo "</table>\n";
	
	$out = ob_get_clean();
	$out = strtolower($out);
	
	return $out;
}

function table_trim($string)
{
	$lines = explode("\n", $string);
	$line_count = count($lines);
	
	$sps = 0;
	
	while(trim($lines[$sps])=="" && $sps<$line_count) $sps++;
	
	if($sps==0) $lines[0] = ltrim($lines[0]);
	
	$result = "";
	while($sps<=$line_count)
	{
		$result.=$lines[$sps]."\n";
		$sps++;
	}

	return rtrim($result);
}

?>
